/* LNB - A procedure to compute the log-likelihood vector for a
**       negative binomial regression model
**
** Notes: Based on King 1989
**
*/

proc lnb(b,d);
    local l,k,s,s1,llfnb,v1,lth,lthy,x,y;
trap 0;
k = cols(d);                    @ set up indexing parameters          @
x = d[.,2:k]; y = d[.,1];       @ set up data                         @
s=b[1,1];                       @ grab the dispersion parameter       @
l = exp(x*b[2:k,1]);            @ compute the mean                    @
v1 = exp((ones(rows(y),1))*s);
lth = exp((x*b[2:k,1]) - s);    @ l./v1;@
lthy = lth + y;

@ compute LLF @
if (sumc(lth.<=0))>0;           @ trap for invalid LLF params @
 llfnb = miss(0,0);
else;

llfnb = lngm(lthy) - lngm(lth) -lnfact(y) + (y.*s) - lthy.*ln(1+v1);
endif;
ndpclex; trap 1;
retp(llfnb);
endp;

