/* LPARP -- PARP LLF
**
** Usage: This procedures computes the Tx1 vector of log-likelihood
**    contributions for the PARP model.  The PARP can be
**    estimated by the procedure PARP, which calls this procedure.
**
** Date: July 13, 1998
**
*/

proc lparp(p,yin);
    local k,d,y,x,s,mu,r,lp;
@ set up data @
    k = cols(yin);
    r = p[k:rows(p),1];
    d = p[1:k-1,1];
    y=yin[.,1];
    x=yin[.,2:k];
@ run filter @
    {mu,s} = parpfilt(y,x,r,d);
x = trimr(x,1,0);   y = trimr(y,1,0);
s = trimr(s,1,0);   mu = trimr(mu,1,0);

if (((s.*mu).<=0))>0;      @ trap for invalid LLF params @
 lp = miss(0,0);
else;

@ compute LLF @
    lp = (lngm((s.*mu) + y)) - lngm(s.*mu) - lnfact(y)
            + (s.*mu).*ln(s) - (s.*mu + y).*ln(1+s);
endif;
ndpclex;
retp(lp);
endp;



