/* LPG -- PEWMA LLF
**
** Usage: This procedures computes the Tx1 vector of log-likelihood
**    contributions for the PEWMA model.  The PEWMA can be
**    estimated by the procedure PEWMA, which calls this procedure.
**
** Date: July 13, 1998
**
**
*/


proc lpg(p,yin);
    local k,d,w,y,x,a1,a2,a3,b1,b2,b3,mu,r,atl,btl,lp;
@ set up data @
    k = cols(yin);
    w = p[1,1];
    d = p[2:k,1];
    y=yin[.,1];
    x=yin[.,2:k];
@ run filter @
    {a1,a2,a3,b1,b2,b3,mu,r} = pewma_filter(y,x,w,d);
x = trimr(x,1,0);   y = trimr(y,1,0);
a1 = trimr(a1,1,0);   b1 = trimr(b1,1,0);   r = trimr(r,1,0);

if (sumc((a1.*w).<=0))>0;      @ trap for invalid LLF params @
 lp = miss(0,0);
else;
@ compute LLF @
    lp = (lngm((w.*a1) + y)) - lngm(w.*a1) - lnfact(y)
        + ((w.*a1) .* ln(w.*b1.*exp(-x*d - r)))
        - ((w.*a1) + y).* (ln(1 + (w.*b1.*exp(-x*d - r))));
endif;
ndpclex;
retp(lp);
endp;
