/* PSI -- Function to compute digamma function
**
** Purpose: Computes the first derivative of the log-gamma function.
**
** Remarks: Based on an approximation in Abramowitz and Stegun
**
** Date: July 13, 1998
**
**/

proc psi(x);
  local p;
  x=x+6;
  p=1/(x.*x);
  p=(((0.004166666666667*p-0.003968253986254).*p+
      0.008333333333333).*p-0.083333333333333).*p;
  p=p+ln(x)-0.5/x-1/(x-1)-1/(x-2)-1/(x-3)-1/(x-4)-1/(x-5)-1/(x-6);
retp(p);
endp;

